' DoFormat from tab v8 02/03/2012
'
' 02/03/2012 v1 move load PBKeyword into DoFormat
'            copied from WinBase.inc 3 routines Declares used in CopyBak
'            moved PowerTime to only routine that uses it
'            fix CopyBak
' 02/04/2012 start work on aligning multiple equates per line
' 02/05/2012 mostly done but need to reformat the EQ part of the line
'             and uppercase equates if needed
' 02/06/2012 reformat the EQ part of multiple equates & capitalize if needed
' 02/07/2012 took out debugging msgboxes
' 02/10/2012 put s_trimba macro in-line
'            moved all beginning of #if %DEF(%AM_SLL) over to SLLDoFormt.bas
'            no need to pass fc to DoFormat -- made hProgress a Global in main bas
' 02/14/2012 fix - splitvariables add $ to old style
'            move check for old style into loop
'            remove spaces for multi-level ()
' 03/17/2012 align continued lines if first ends in = or (
' 03/25/2012 allow for multi-quoted strings -- quit when next char isn't a quote & even number of quotes
'

Global strTbl()         As String
Global PBKeyWords()     As String ' mixed case
Global macro_w_params() As String ' 01/16/2012
Global macro_usage()    As Long

Macro Construct(P1, P2)
Case P1
   If Is_there(w(), P2, WordCount) Then
      If (WordNo = 1) Then spacer = spacer + fo.tabsize
   End If
End Macro

Macro m_ExitFunction(nresult)
  Function = nresult
  Exit Function
End Macro

#If Not %Def(%AM_DLL)
Global fc As fmtcommon
#EndIf

Sub DoFormat(xfo As FMTOPTIONS) Common ' 02/03/2012
   '----------------------------------------------------------------------------
   'Format the source file. The w(1-x) array holds words, tokens, strings
   'of parsed source line data.
   ' 11/18/2011 PDE following obsolete --- tacked on end of affected line -- much neater
   'w(0) element is reserved for any in-line comment
   'that doesn't fit to be placed above the affected line.
   '----------------------------------------------------------------------------
   Local Wordcount          As Long                    '# tokens in source line
   Local CurrentLine        As Long                    '0 based current edit line number
   Local TotalLines         As Long                    'total # lines in control
   Local ztext              As AsciiZ * %MAX_LINELEN   'source code line
   Dim   w(100)             As Local String            'words/tokens in line
   Local build              As String                  'rebuilt source line
   Local isvariableline     As Long
   Local isvariablecont     As Long
   Local iscontin           As Long
   Local holdvariablecont   As String
   Local holdvariableremark As String
   Local rtc                As Long
   Local x                  As Long
   Local y                  As Long
   Local cParen             As Long
   Local cEqual             As Long
   Local isMacroWParam      As Long
   Local wrk1               As Long
   Local found1             As Long
   Local skip               As Long
   Local hfc                As fmtcommon
   Local zOut               As AsciiZ * %Max_Path

   Static pbloc             As Long
   Static onetime           As Long
   Static lastKW            As String

   If onetime = 0 Then
      Dim macro_w_params(100) As Global String
      Dim macro_usage(1,100) As Global Long
      onetime = 1
   End If

   fc = hfc ' clear it out

#If %Def(%AM_SLL)
   fo = xfo
#EndIf

   If fo.keywordCase <> 1 Then
      If fo.PBCompiler <> lastKW Then
         If fo.PBCompiler = "WIN" Then
            LdWn10Keys
         ElseIf fo.PBCompiler = "CC" Then
            LdCC06Keys
         Else
            ReDim PBKeyWords(1 To 1) As Global String
         End If
         lastKW = fo.PBCompiler
      End If
   End If

   CopyBak

   GetTempPath %Max_Path, ztext
   GetTempFileName ztext, "fmt", 0, zOut ' 11/18/2011 fo.fspecout
   fc.fhin = FreeFile
   Open fo.fspecin For Input Access Read As fc.fhin
   fc.fhout = FreeFile
   Open zOut For Output As fc.fhout

   '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   'Start formatting, fetch each source line, parse into
   'tokens/words, rebuild it according to user preferences,
   'and add to temp file.
   '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   FileScan fc.fhin, Records To TotalLines      'total source code lines
   ReDim strTbl(1 To TotalLines) As Global String ' Global
   Line Input #fc.fhin, strTbl()
   For x = 1 To TotalLines
      strTbl(x) = Tab$(strTbl(x), fo.tabsize)
   Next

   fc.totallines = TotalLines

   Reset macro_w_params()
   Reset macro_usage()

   Show_ProgressBar

   For CurrentLine = 1 To TotalLines

      If (CurrentLine Mod 100) = 0 Then           'update the progress control
         pbloc = 100 * (CurrentLine / TotalLines)
         If pbloc > 100 Then pbloc = 1
         Update_ProgressBar pbloc
      End If
#If 0
      If skip > 0 Then
         Decr skip
         Iterate For
      End If
#EndIf
      ztext = strTbl(CurrentLine)
      WordCount = Line2Words(ztext, w())

      fc.currentline = CurrentLine

      Array Scan w(1) For WordCount, Collate UCase, = "REM", To x
      If x > 1 Then
         If w(x - 1) = ":" Then
            w(x - 1) = "'"
            w(x) = ""
            For y = x + 1 To WordCount
               w(x - 1) &= " " & w(y)
               w(y) = ""
            Next
            WordCount = x - 1
         End If
      End If

      ' work-around
      If fo.formatmacro = 0 And UCase$(Left$(ztext, 6)) = "MACRO " Then
         fo.formatmacro = 2
         hfc = fc ' put current on hold
         WordCount = Line2Words(ztext, w())
      End If

      ' check for Macro with Params
      If UCase$(w(1)) = "MACRO" Then
         If fo.formatmacro = 2 Then fc = hfc ' put it back
         Array Scan w(1) For WordCount, = "(", To cParen
         Array Scan w(1) For WordCount, = "=", To cEqual
         isMacroWParam = 0
         If cParen > 0 And cEqual > cParen Then isMacroWParam = 1
         If cParen > 0 And cEqual = 0 Then isMacroWParam = 1
         If isMacroWParam = 1 Then
            If fc.macro_w_params = UBound(macro_w_params()) Then
               ReDim Preserve macro_w_params(fc.macro_w_params + 100)
               ReDim Preserve macro_usage(1, fc.macro_w_params + 100)
            End If
            Incr fc.macro_w_params
            x = 2
            If UCase$(w(2)) = "FUNCTION" Then x = 3
            macro_w_params(fc.macro_w_params) = w(x)
            macro_usage(0, fc.macro_w_params) = fc.currentline
         End If
      End If

      If fc.macro_w_params > 0 Then
         Do
            found1 = 0
            For wrk1 = WordCount To 1 Step -1
               Array Scan macro_w_params(1) For fc.macro_w_params, Collate UCase, = UCase$(w(wrk1)), To x
               If x > 0 And w(wrk1 + 1) = "(" And macro_usage(0, x) <> fc.currentline Then
                  Incr macro_usage(1, x)
                  found1 = 1
                  ' need to collapse
                  cParen = 0
                  cEqual = 0
                  For y = wrk1 + 1 To WordCount
                     If w(y) = "(" Then Incr cParen
                     If w(y) = ")" Then Decr cParen
                     w(wrk1) &= w(y)
                     Incr cEqual
                     w(y) = ""
                     If cParen = 0 Then
                        Exit For
                     End If
                  Next
                  For y = 1 To cEqual
                     Array Delete w(wrk1 + 1)
                  Next
                  WordCount -= cEqual
               End If
            Next
         Loop While found1 = 1
         ' if found1 then do it again -- macros within macros
      End If

      ' work-around done
      If fo.formatmacro = 2 Then
         fo.formatmacro = 0
         Reset w()
         WordCount = 1
         w(1) = ztext
         w(2) = ""
      End If

      Select Case UCase$(w(1))              'process the token
         ' if variables then dump individual items
         Case "GLOBAL", "REGISTER", "DIM", "LOCAL", "STATIC", "INSTANCE", "REDIM"
            isvariableline = 1
            If %DMPVAR = 1 Then
               x = FreeFile
               Open "var.txt" For Append As #x
               Print #x, ztext, Str$(fc.indent)
               For y = 1 To WordCount
                  Print #x, y, ">>";w(y);"<<"
               Next
               Close #x
            End If

         Case Else
            isvariableline = 0
      End Select

      ' check for continuation variable lines
      If w(WordCount) = "_" Or w(WordCount - 1) = "_" Then
         iscontin = 1
      Else
         iscontin = 0
      End If

      If fo.splitvariables = 1 Then

         If isvariableline = 1 And iscontin = 1 And isvariablecont = 0 Then
            isvariablecont = 1
            If Left$(w(WordCount), 1) = "'" Then ' remark on end
               holdvariableremark &= w(WordCount) & " | " ' string remarks together
               ztext = Left$(ztext, Len(ztext) - Len(w(WordCount))) ' remove the remark
               w(WordCount) = ""
               Decr WordCount
            End If
            ztext = RTrim$(ztext) ' remove any trailing spaces
            ztext = Left$(ztext, Len(ztext) - 1 ) ' should remove _
            holdvariablecont &= ztext ' put it in hold
            Iterate For
         End If

         ' check for lines after 1st -- won't be flagged as variableline but will be contin
         If isvariableline = 0 And iscontin = 1 And isvariablecont = 1 Then
            If Left$(w(WordCount), 1) = "'" Then ' remark on end
               holdvariableremark &= w(WordCount) & " | " ' string remarks together
               ztext = Left$(ztext, Len(ztext) - Len(w(WordCount))) ' remove the remark
               w(WordCount) = ""
               Decr WordCount
            End If
            ztext = RTrim$(ztext) ' remove any trailing spaces
            ztext = Left$(ztext, Len(ztext) - 1 ) ' should remove _
            holdvariablecont &= ztext ' put it in hold
            Iterate For
         End If

         ' check for 1st line after variable contin -- won't be flagged as variableline nor contin
         If isvariableline = 0 And iscontin = 0 And isvariablecont = 1 Then
            If Left$(w(WordCount), 1) = "'" Then ' remark on end
               holdvariableremark &= w(WordCount) ' string remarks together
               ztext = Left$(ztext, Len(ztext) - Len(w(WordCount))) ' remove the remark
               w(WordCount) = ""
               Decr WordCount
            End If
            ztext = RTrim$(ztext) ' remove any trailing spaces
            holdvariablecont &= ztext ' put it in hold
            ztext = holdvariablecont & " " & holdvariableremark ' combine back together
            WordCount = Line2Words(ztext, w()) ' break apart again
            isvariablecont = 0 ' reset flags/hold areas
            isvariableline = 1
            holdvariablecont = ""
            holdvariableremark = ""
         End If
      End If

      ' do this after combining lines
      If fo.keywordCase <> 1 Then
         CheckPBKeywordCase 1, WordCount, w()
      End If

      If fo.splitvariables = 1 And isvariableline = 1 Then
         rtc = SplitVariables(w(), WordCount, ztext)
      Else

         ' check for multiple integer equates on a line
         If Left$(w(1), 1) = "%" And w(2) = "=" Then
            Array Scan w(4) For WordCount - 3, Collate UCase, = ":", To x
            If x > 0 And Left$(w(x + 4), 1) = "%" Then
               MultEquateLine
               CurrentLine = fc.currentline
               Iterate For
            End If
         End If

         build = RebuildLine(w(), WordCount)
         Print #fc.fhout, build

         If UCase$(w(1)) = "TYPE" And UCase$(w(2)) <> "SET" Then ' align TYPE/UNION variables
            AlignTypeUnion
            CurrentLIne = fc.currentline
         End If

         If UCase$(w(1)) = "UNION" Then ' align TYPE/UNION variables
            AlignTypeUnion
            CurrentLIne = fc.currentline
         End If

         If UCase$(w(1)) = "ENUM" Then ' indent ENUM 12/24/2011
            IndentEnum
            CurrentLine = fc.currentline
         End If

      End If
   Next

   Sleep 2000
   Hide_ProgressBar fc.maxtokens

   If fc.fhdmp <> 0 Then
      Close fc.fhdmp
      fc.fhdmp = 0
   End If

   Close fc.fhin, fc.fhout
   FileCopy zOut, fo.fspecout
   Kill zOut

   y = FreeFile
   Open "macro.usg" For Append As #y
   Print #y, "output "; fo.fspecout
   For x = 1 To fc.macro_w_params
      'IF macro_usage(1,x) > 0 THEN
         Print #y,Format$(macro_usage(1,x), "* #### "); macro_w_params(x)
      'END IF
   Next
   Print #y, ""
   Close #y

#If %Def(%AM_SLL)
   xfo = fo
#EndIf

End Sub

Sub CopyBak
   Local p As String
   Local f As String
   Local fout As String
   Local d As String
   Local t As String
   Dim Built As IPowerTime

   Let Built = Class "PowerTime"

   Built.Now()

   f = PathName$(Name, fo.fspecin)
   If fo.backup Then
      If fo.backupTimeStamp = 0 Then
         p = PathName$(Path, fo.fspecin)
         fout = p + f + ".BAK"
         ' CopyFile fo.fspecin, fout, 0
         FileCopy fo.fspecin, fout
      Else
         p = PathName$(Path, fo.fspecin) + "BAK"
         If IsFolder(p) = 0 Then
            MkDir p
            p &= "\"
         End If
         d = Built.DateString
         Replace "/" With "_" In d
         t = Built.TimeString
         Replace ":" With "_" In t
         fout = p + "\" + f + "_"+ d + "_" + t + ".BAK"
         'CopyFile fo.fspecin, fout, 0
         FileCopy fo.fspecin, fout
       End If
   End If
End Sub

Function Line2Words(ByRef work As AsciiZ * %MAX_LINELEN, ByRef w() As String ) As Long ' 11/18/2011
   '-------------------------------------------------------------------
   'Parse source line into word/token array w(). Handle special cases for
   'REM, DATA, string literals, ASM, !, '.
   '  work     [in/out] source code line text
   '  w()      [in/out] array of words/tokens
   ' NOPE  fo       [in/out] udt of formatting options
   'Returns count of words/tokens found
   '-------------------------------------------------------------------
   Local stemp As String
   Local ncount As Long                          'word/token count
   Local pchr As Byte Ptr
   Local s1 As Long
   Local cntQuotes As Long

   ReDim w(100)                                  ' clears out any previous text

   work = Trim$(work, Any Chr$(0 To 32))
   stemp = UCase$(Trim$(work))                   'standardize incomming text
   '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   'These need no or limited processing
   '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   If Left$(stemp, 1) = "'"       Or _           'remark
      Len(stemp) = 0              Or _           'blank line
      Left$(stemp, 5) = "DATA "   Or _           'DATA statments ignored
      Left$(stemp, 7) = "#PBFORM" Or _
      Left$(stemp, 7) = "$PBFORM" Then
         w(1) = Trim$(work)
         m_ExitFunction(1)
   ElseIf Left$(stemp, 4) = "REM " Then
      w(1) = "' " + Trim$(Mid$(work, 5))         'replace REM with '
      m_ExitFunction(1)
   ElseIf Left$(stemp, 4) = "ASM " Then          'replace ASM with !
      w(1) = "!" + RTrim$(Extract$(Mid$(work, 5), Any "';"))
      w(2) = ";" + Trim$(Remain$(work, Any ";'"))
      m_ExitFunction(2)
   ElseIf Left$(stemp, 1) = "!" Then
      w(1) = Trim$(Extract$(work, Any "';"))     'up to any comment
      w(2) = ";" + Trim$(Remain$(work, Any ";'"))
      m_ExitFunction(2)                          'two words/tokens
   ElseIf fo.formatMacro = 0 Then                ' do not format Macros  -- return everything in w(1)
      If fc.inMacro1 > 0 Then
         If Left$(stemp, 4) = "END " And InStr(stemp, "MACRO") Then
            Decr fc.inMacro1
         End If
         w(1) = work
         m_ExitFunction(1)
      ElseIf Left$(stemp, 6) = "MACRO " Then
         s1 = InStr(stemp, "=")
         If s1 = 0 Then Incr fc.inMacro1
         w(1) = work
         m_ExitFunction(1)
      End If
   End If
   stemp = ""                                    'clear for reuse
   '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   'Parse remainder
   '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   pchr = VarPtr(work)                           'point to first byte
   Do
      If @pchr = 34 Then                         'quote start?
         GoSub SaveWord                          'save any current word/token
         cntQuotes = 1
         s1 = pchr                               'save string start
         Do
            Incr pchr                            'next string character
            If @pchr = 34 Then Incr cntQuotes
            If @pchr = 0 And cntQuotes Mod 2 <> 0 Then
               cntQuotes = 2 ' force it -- malformed quoted string ?
               Print #fc.fhout, "*** malformed quoted string in "; work
            End If
         Loop Until (@pchr <> 34) And cntQuotes Mod 2 = 0 ' 03/24/2012 allow for multi-quotes
         Decr pchr ' do not go past end of string for normal quoted
         'Loop Until @pchr = 34                   'quoted string finished -- replaced 03/24/2012
         stemp = Peek$(s1, pchr - s1 + 1)
         If %DmpIt Then Print #fc.fhout, "cq = "; cntQuotes; " >>"; @pchr
         GoSub SaveWord
         Incr pchr                               'next byte/character
         Iterate Do
      End If
      If @pchr = 39 Then                         'inline "'" remark
         GoSub SaveWord
         'balance of line
         stemp = Mid$(work, pchr - VarPtr(work) + 1)
         Exit Do                                 'line done
      End If
      '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      'Check for one of the standard delimters
      '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      If InStr( " ,\=+-/^*)(:[];><.", Chr$(@pchr)) Then
         GoSub SaveWord
         If @pchr <> 32 Then
            stemp = Chr$(@pchr)
            GoSub SaveWord
         End If
      Else
         stemp = stemp + Chr$(@pchr)             'add char to current token
      End If
      Incr pchr
   Loop While @pchr <> 0                         'check for line end
   GoSub SaveWord
   If ncount > fc.maxtokens Then fc.maxtokens = ncount ' 12/10/2011
   m_ExitFunction(ncount)                        'return token count

SaveWord:
   If Len(stemp) Then                            'anything to do?
      Incr ncount                                'next array element
      If UCase$(stemp) = "REM" Then
         stemp = "REM"
      '   stemp = "'" & MID$(work, pchr - VARPTR(work) + 1)  ' change REM to '
      '   ' MSGBOX "rem >" & stemp & "<<"
      '   mid$(work, pchr - varptr(work), len(stemp) + 7) = string$(len(stemp) + 7, chr$(0)) ' VARPTR(work) + LEN(work)
      End If
      w(ncount) = stemp                          'save it
      stemp = ""                                 'erase working string
   End If
   Return

End Function

Function RebuildLine(ByRef w() As String, ByRef wordcount As Long) As String ' 11/18/2011
   '----------------------------------------------------------------
   'Reassemble a source line from the individual tokens in string
   'array Words() standardize puncuation, spacing and indentation.
   '  w()         [in/out] array of source words/tokens
   '  wordcount   [in/out] # words/tokens in array
   ' NOPE   fo          [in/out] udt of formatting options
   'Returns the formatted source code line
   '
   ' indent = indenting of this line
   ' spacer = indenting of next line
   '----------------------------------------------------------------
   Local i& ' NASTY HABIT
   Local stemp    As String
   Local comment  As String
   Local schr     As String
   Local spacer   As Long                        'helper with indenting
   Local WordNo   As Long
   Local dmpx     As Long
   Local isequate As Long
   Local s1       As Long
   Local x        As Long
   Local y        As Long
   Local z        As Long

   schr = Left$(w(1), 1)
   If schr = "'" Then
      m_ExitFunction(Space$(fc.indent) & w(1))   'return full comment line
   ElseIf UCase$(Left$(w(1), 5)) = "DATA " Then  'line is data 01/18/2012 fix
      m_ExitFunction(Space$(fc.indent) & w(1))
   ElseIf UCase$(Left$(w(1), 7)) = "#PBFORM"   Or _  ' line is PBForm line 01/14/2012
          UCase$(Left$(w(1), 7)) = "$PBFORM" Then
      m_ExitFunction(w(1))                       'return unmodified
   ElseIf schr = "!" Then
      If Len(w(2)) > 1 Then                      'inline assembler comment
         stemp = LSet$(Space$(fc.indent) & w(1), fo.remcol - 1) & w(2)
      Else
         stemp = Space$(fc.indent) & w(1)
      End If
      m_ExitFunction(stemp)
   End If
   '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   'If last item in token array is a inline comment, save it to
   'be inserted later.
   '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   schr = Left$(w(WordCount), 1)
   If schr = "'" Or schr = ";" Then
      comment = w(WordCount)
      If Len(comment) <= 1 Then
         comment = ""                            'make blank line
      End If
      Decr WordCount
   End If

   If fo.lineupequates Then
      schr = Left$(w(1), 1)
      If (schr = "%" Or schr = "$") And w(2) = "=" Then
         If fo.capequates Then
            w(1) = UCase$(w(1))
         End If
         i& = Max&(Len(w(1)) + 2, fo.equatescolumn)
         stemp = LSet$(w(1), i& - 2) & " =" ' 12/21/2011 fix for spacing of multi parts
         For i& = 3 To wordcount
            If Left$(w(i&), 1) = "%" Or Left$(w(i&), 1) = "$" Then
               If fo.capequates Then w(i&) = UCase$(w(i&))
            End If
            stemp &= " " & Trim$(w(i&))
         Next
         If Len(comment) And Len(stemp) < fo.remcol - 1 Then
            stemp = LSet$(stemp, fo.remcol - 1) & Trim$(comment)
         Else
            'w(0) = comment
            stemp = RTrim$(stemp) & Space$(fo.tabsize) & comment ' 11/18/2011 PDE
            comment = ""
         End If
         m_ExitFunction(stemp)
      End If
   End If

   If fo.formatMacro = 0 Then                ' do not format Macros
      schr = strTbl(fc.currentline)
      stemp = UCase$(schr)
      If fc.inMacro2 > 0 Then
         If Left$(stemp, 4) = "END " And InStr(stemp, "MACRO") Then
            Decr fc.inMacro2
         End If
         stemp = schr
         m_ExitFunction(stemp)
      ElseIf Left$(stemp, 6) = "MACRO " Then
         s1 = InStr(stemp, "=")
         If s1 = 0 Then Incr fc.inMacro2
         stemp = schr
         m_ExitFunction(stemp)
      End If
   End If

   If w(wordcount) = "_" Then
      fc.inContin = 1
   End If
   '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   'process each token in array w()
   '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   stemp = ""
   Do
      Incr WordNo                                'first/next word
      '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      'Is word abreviated print statement ?. Expand and capitilize
      '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      schr = Left$(w(WordNo), 1)
      If w(WordNo) = "?" Then
         If fo.PBCompiler = "CC" Then
            w(WordNo) = "PRINT"                  'expand to PRINT (PBCC)
         ElseIf fo.PBCompiler = "WIN" Then
            w(WordNo) = "MSGBOX"                 'expand to MSGBOX (PBWIN)
         End If
      ElseIf schr = $Dq Then                     'string literal
         stemp &= w(WordNo) & " "                'simply add it
         Iterate Do
      ElseIf schr = "%" Or schr = "$" Then       'equates
         isequate = 1 ' 12/31/2011
         Select Case UCase$(w(WordNo))
            Case "$ALIGN", "$BLOAT", "$COM", "$COMPILE", "$COMPILER", "$DEBUG", "$DIM", _
                 "$ELSE", "$ELSEIF", "$ENDIF", "$EXPORT", "$IF", "$INCLUDE", "$MESSAGES", _
                 "$OPTION", "$PBFORMS", "$REGISTER", "$RESOURCE", "$STACK", "$TOOLS", "$UTILITY"
                 isequate = 0
         End Select
         If fo.capequates And fo.lineupequates And isequate = 1 Then ' 12/31/2011 fix
            w(WordNo) = UCase$(w(WordNo))
         End If
      ElseIf schr = "!" Then
         stemp &= w(WordNo)                      'assembler line
         spacer = fc.indent
         fc.indent = 0
         Exit Do
      End If

      Select Case UCase$(w(WordNo))              'process the token
            '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            'Check to see if token is a label (wordcount = 2), only thing
            'allowed on a line with a label is a comment and that was
            'removed above. Should it fail this test its assumed to be
            'part of a multi-statement line. Labels always start in col 1
            '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
         Case ":"                                'check for label
            stemp = RTrim$(stemp)
            If WordCount = 2 Then                'we assume a label (name + :)
               spacer = fc.indent                'save indent value
               fc.indent = 0                     'move label to left margin
            End If

            '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            'Try to distinguish between array and something else as to
            'whether or not there should be a space preecding these. Need
            'to test for a PB intrinsic function like ATTRIB(xxx) vs OR
            '(xx + yy).
            '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
         Case "(", "["
            If InStr( "+-*/\=><", w(WordNo - 1)) = 0 Then
               stemp = RTrim$(stemp)
            End If
            Select Case UCase$(w(WordNo - 1))
               Case "IF", "ELSEIF", "AND", "OR", "NOT", "ISFALSE", "ISTRUE", "XOR", "TO"
                  stemp &= " "                   'add spacing
            End Select

            '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            'We never want any space to proceed these delimiters
            '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
         Case ")", ",", "]", "[", ";", "."
            stemp = RTrim$(stemp)                'no preceding space

            '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            'Catch <>, >=, <= combinations to eliminate < >, > =,. etc.
            '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
         Case "<", ">", "="
            If InStr( "<>=+-*ORAND", w(WordNo - 1)) Then ' 05/06/2011 PDE added + - * not sure how to handle OR AND
               stemp = RTrim$(stemp)
            End If

            '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            'Compare last token to THEN, nothing else on line means started
            'a multi-line IF block. Any comment already removed above.
            '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
         Case "THEN"
            If WordNo = WordCount Then
               spacer += fo.tabsize              'change for next line
            End If

         Case "TYPE"
            If WordNo = 1 And UCase$(w(2)) <> "SET" Then
               spacer += fo.tabsize
            End If

         Case "UNION", "ENUM", "SUB", "ASMDATA", "PREFIX" ' 01/31/2012 add PREFIX
            If WordNo = 1  Then
               spacer += fo.tabsize
            End If

         Case "FUNCTION", "INTERFACE", "PROPERTY", "FASTPROC" ' INTERFACE has no =
            If WordNo = 1 And w(2) <> "=" Then
               spacer += fo.tabsize
            End If

         Case "CLASS"
            If WordNo = 1 And UCase$(w(2)) <> "METHOD" Then
               Incr fc.inClass
            End If
            If WordNo = 1 And w(2) <> "=" Then
               spacer += fo.tabsize
            End If

         Case "METHOD"
            If WordNo = 1 Then ' 12/19/2011 change add =
               If w(2) = "=" Then
                  ' no change
               ElseIf fc.inClass > 0 Then
                  spacer += fo.tabsize ' next line
               End If
            End If

            '         case "FOR"
            '          if Is_there(w(),"NEXT",WordCount) then
            '             IF (WordNo = 1) THEN spacer = spacer + fo.tabsize
            '          end if
            Construct( "FOR", "NEXT")
            Construct( "WHILE", "WEND")
            Construct( "DO", "LOOP")

         Case "MACRO"
            If WordNo = 1 And UCase$(w(2)) = "FUNCTION" Then
               spacer += fo.tabsize
            End If

         Case "CALLBACK", "THREAD" ' 05/09/2011 PDE need to indent same as normal FUNCTION
            If WordNo = 1 And UCase$(w(2)) = "FUNCTION" Then
               spacer += fo.tabsize
            End If

         Case "SELECT", "TRY"
            If WordNo = 1 Then spacer += (fo.tabsize * 2)

            '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            'Handle ELSEIF seperately since it appears on same line with THEN
            '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
         Case "#IF", "$IF"                       'these require no line ending THEN
            spacer = fc.indent ' next line
            fc.indent = 0 ' this line

         Case "ELSEIF"                           ' change this line
            fc.indent -= fo.tabsize

         Case "#ELSEIF", "$ELSEIF", "#ELSE", "$ELSE"
            If WordNo = 1 Then                   'first word?  ' 01/21/2012 fix
               spacer = fc.indent ' next line
               fc.indent = 0 ' this line
            End If
         Case "#ENDIF", "$ENDIF"
            spacer = fc.indent
            fc.indent = 0 ' -= fo.tabsize

         Case "ELSE", "CASE", "CATCH", "FINALLY"
            If WordNo = 1 Then                   'first word?
               spacer += fo.tabsize              'change for next line
               fc.indent -= fo.tabsize           'change for this line
            End If

         Case "END"
            Select Case UCase$(w(WordNo + 1))
               Case "TYPE", "IF", "UNION", "SUB", "FUNCTION", "INTERFACE", "MACRO", "METHOD", "PROPERTY", "ENUM", "FASTPROC", "ASMDATA", "PREFIX" ' 01/31/2012 add PREFIX
                  fc.indent -= fo.tabsize
               Case "CLASS"
                  Decr fc.inClass
                  spacer = 0 ' next line
                  fc.indent -= fo.tabsize ' this line
               Case "SELECT", "TRY"
                  fc.indent -= (fo.tabsize * 2)
            End Select

            '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            'Check for the close of a looping block. If its on the same
            'line as loop start, keep same indent.
            '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
         Case "WEND", "NEXT", "LOOP"
            If wordno = 1 Then
               schr = UCase$(stemp)              'standardize
               spacer = 0                        'be sure this = 0
               fc.indent -= fo.tabsize           'default is close loop
               If InStr(schr, "DO ") Then
                  fc.indent += fo.tabsize
               ElseIf InStr(schr, "WHILE ") Then
                  fc.indent += fo.tabsize
               ElseIf InStr(schr, "ITERATE") Then
                  fc.indent += fo.tabsize
               End If
            End If

         ' if variables then dump individual items
         Case "GLOBAL", "REGISTER", "DIM", "LOCAL", "STATIC", "INSTANCE", "REDIM"
            If wordno = 1 Then
               If fc.fhdmp = 0 Then
                  fc.fhdmp = FreeFile
                  Open "cf.dmp" For Output As #fc.fhdmp
               End If
               Print #fc.fhdmp, "#"; fc.currentline
               For dmpx = 1 To WordCount
                  Print #fc.fhdmp, dmpx, ">>";w(dmpx);"<<"
               Next
               Print #fc.fhdmp, ""
            End If
      End Select

      '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      'No space following "([]"
      '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      If w(wordno) = "." Then
         stemp = RTrim$(stemp) & "."
      ElseIf w(WordNo - 1) = "(" And w(WordNo) = "_" Then ' fix 12/07/2011
         stemp &= w(WordNo)
      ElseIf InStr( "(][", w(WordNo - 1)) Then
         stemp = RTrim$(stemp) & w(WordNo) & " "
      ElseIf Right$(w(WordNo - 1), 1) = Chr$(34) And Left$(w(WordNo), 1) = "$" Then ' 01/18/2012
         stemp = RTrim$(stemp) & w(WordNo) & " "
      Else
         stemp &= w(WordNo) & " "
      End If

   Loop While WordNo < WordCount

   If fc.indent < 0 Then fc.indent = 0                    'stay at left margin
   If fc.inContin = 1 Then
      If fc.ContIndentCnt = 0 Then

         fc.ContinIndentFix = 0 ' 03/17/2012
         x = InStr(-1, stemp, "=")
         y = InStr(-1, stemp, "(")
         If y > x Then x = y
         If x > 0 And x < Len(stemp) Then
            If Mid$(stemp, x + 1, 1) = " " Then
               fc.ContinIndentFix = x + 1 + fc.indent
            Else
               fc.ContinIndentFix = x + fc.indent
            End If
         End If

         fc.ContinIndent = fc.indent
         Incr fc.ContIndentCnt
      End If
      stemp = Space$(fc.ContinIndent) + RTrim$(stemp)     'final formated line
      If fc.ContIndentCnt = 1 Then
         If fc.ContinIndentFix = 0 Then
            fc.ContinIndent += fo.tabsize
         Else
            fc.ContinIndent = fc.ContinIndentFix
         End If
         Incr fc.ContIndentCnt
      End If
      If w(wordcount) <> "_" Then ' did this get removed above ?
         fc.InContin = 0
         fc.ContinIndent = 0
         fc.ContIndentCnt = 0
         fc.ContinIndentFix = 0
      End If
   Else
      stemp = Space$(fc.indent) + RTrim$(stemp)           'final formated line
   End If

cleanup:
   '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   'Add any line comment preserved above.
   ' force fit if not enough room
   '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   w(0) = ""
   If Len(comment) Then
      If Len(stemp) < fo.remcol Then
         stemp = Left$(stemp & Space$(fo.RemCol - 1), fo.RemCol - 1) & comment
      Else
         ' w(0) = SPACE$(fo.indent) + comment 11/18/2011
         stemp = RTrim$(stemp) & Space$(fo.tabsize) & comment ' 11/18/2011
         comment = ""
      End If
   End If
   fc.indent += spacer                           'new indent value
   Function = stemp                              'return formatted source line
End Function

'----------------------------------------------------------------

Function Is_there(ByRef w() As String, ByVal S01 As String, ByVal wc As Long) As Long
   Register R01 As Long, R02 As Long
   R02 = 0
   For R01 = 2 To wc
      If Trim$(UCase$(w(R01))) = UCase$(S01) Then R02 = 1
   Next
   Function = 1 - R02                            ' Inverted for easier usage
End Function

Function SplitVariables(ByRef w()As String, ByRef WordCount As Long, ztext As AsciiZ * %MAX_LINELEN ) As Long

   ' 05/06/2011 PDE expand GLOBAL/LOCAL to 1 variable per line
   Local str1 As String
   Local str2 As String
   Local strAs As String
   Local holdAS As String
   Local comment As String

   Dim   vars(100) As String
   Local varstr As String
   Local varfixsize As String
   Local maxfixsize As Long
   Local varcnt As Long
   Local varDeclare As String
   Local varDeclareSize As Long
   Local inParens As Long
   Local oldstyle As Long

   Local a As Long
   Local b As Long
   Local ixBase As Long
   Local ixEndAS As Long
   Local ixColon As Long
   Local ixComma As Long
   Local ixAS As Long
   Local preAS As Long

   Local rtc As Long

   ' 06/21/2011 PDE split up Global/Local to 1 variable per line
   If fo.ascolumn < 1 Then
      fo.ascolumn = 40
   End If

   str1 = w(WordCount)
   str2 = Left$(str1, 1)
   If str2 = "'" Then
      comment = str1
      w(WordCount) = ""
      Decr WordCount
   End If

   If w(WordCount) = "_" Then ' will be taken care of earlier
      w(WordCount) = ""
      Decr WordCount
   End If
   If w(WordCount) = "," Or w(WordCount) = ":" Then ' should be taken care of earlier
      w(WordCount) = ""
      Decr WordCount
   End If

   inParens = 0 ' mask "," & ":" within parens
                ' do NOT forget to unmask anything that goes thru Line2Word/RebuildLine
   For a = 1 To WordCount
      If w(a) = "(" Then inParens = 1
      If w(a) = ")" Then inParens = 0
      If w(a) = "," And inParens = 1 Then w(a) = Chr$(254)
      If w(a) = ":" And inParens = 1 Then w(a) = Chr$(253)
   Next

   varDeclare = Space$(9) ' so far largest type
   varDeclareSize = 9
   ixBase = 1 ' base idx
agn:
   LSet varDeclare = w(ixBase)
   str1 = UCase$(w(ixBase))
   If str1 = "GLOBAL" Or str1 = "REGISTER" Or str1 = "DIM" Or str1 = "LOCAL" Or _
      str1 = "STATIC" Or str1 = "INSTANCE" Or str1 = "REDIM" Then
      GoTo agn2
   End If
   ' not a variable -- build until : or eol
   varcnt = 0
   inParens = 0
   Do
      If w(ixBase) = "(" Then inParens = 1
      If w(ixBase) = ")" Then inParens = 0
      If w(ixBase) = Chr$(254) And inParens = 1 Then w(ixBase) = ","
      If w(ixBase) = Chr$(253) And inParens = 1 Then w(ixBase) = ":"
      Incr varcnt
      vars(varcnt) = w(ixBase)
      Incr ixBase
   Loop Until w(ixBase) = "" Or w(ixBase) = ":"
   If w(ixBase) = "" And Len(comment) > 0 Then
      Incr varcnt
      vars(varcnt) = comment
   End If
   If vars(1) <> "" Then
      str1 = RebuildLine(vars(), varcnt)
      Print #fc.fhout, str1
   End If
   str1 = ""
   If w(ixBase) = ":" Then ' still more
      Incr ixBase
      GoTo agn
   End If
   ' end of line
   rtc = 1
   GoTo DunSplit

agn2:
   preAS = fo.ascolumn - 2
   If Left$(UCase$(varDeclare), 3) <> "GLO" Then ' allow for indenting except Globals
      preAs -= fc.indent
   End If

   maxfixsize = preAs - varDeclareSize
   varfixsize = Space$(maxfixsize)

   Array Scan w(ixBase) For WordCount, Collate UCase, = "AS", To ixAS ' idx to first AS
   If ixAS <= 0 Then
      oldstyle = 99
      strAS = ""
      If %DmpIt Then Print #fc.fhout, "no AS found"
      GoTo NoAs
      'PRINT #fc.fhout, "ixAS <= 0"; STR$(ixAS); " ixBase ="; STR$(ixBase)
      'str1 = RebuildLine(w(), WordCount)
      'PRINT #fc.fhout, str1
      'rtc = -1
      'GOTO DunSplit ' old style?
   End If

   strAS = " " & w(ixAS + ixBase - 1)
   a = ixAS + ixBase ' entry after AS

   If %DmpIt Then Print #fc.fhout, "before a ="; Str$(a); ">>";w(a -1);"<<"

   ' keep adding until ,: or eol
   inParens = 0
   Do
      If a > WordCount Then Exit Loop
      If w(a) = ""  Then Exit Loop
      If w(a) = ":" Then Exit Loop
      If w(a) = "," Then Exit Loop
      If w(a) = "(" Then Incr inParens
      If inParens > 0 Then
         strAS &= w(a)
      Else
         strAS &= " " & w(a)
      End If
      If w(a) = ")" Then Decr inParens
      Incr a
   Loop

   Replace " . " With "." In strAS ' remove spaces around .

   ixEndAS = a ' entry after AS .....
   strAS = RTrim$(strAS) ' unmask , : within parens
   For a = 1 To Len(strAS)
      If Mid$(strAS, a, 1) = Chr$(254) Then Mid$(strAS, a, 1) = ","
      If Mid$(strAS, a, 1) = Chr$(253) Then Mid$(strAS, a, 1) = ":"
   Next

   If %DmpIt Then Print #fc.fhout, "a ="; Str$(a); ">>";w(a);"<<"; " strAS =>"; strAS;"<"

   Array Scan w(ixBase) For ixAS, = ",", To ixComma ' idx to first ,
   Array Scan w(ixBase) For ixAS, = ":", To ixColon ' idx to first :
   If ixComma > 0 Then ixComma += ixBase - 1 ' adjust based on whole array
   If ixColon > 0 Then ixColon += ixBase - 1
   If %DmpIt Then
      Print #fc.fhout, "ixComma ="; Str$(ixComma)
      Print #fc.fhout, "ixColon ="; Str$(ixColon)
   End If
   If ixColon > 0 And ixColon < ixAS Then
      strAs = "" ' AS falls after :
      If %DmpIt Then Print #fc.fhout, "AS";Str$(ixAS);" falls after :";Str$(ixColon)
   End If

   ixAS += ixBase - 1 ' adjust based on whole array

NoAS:
   rtc = 0
   b = ixBase + 1 ' first entry after Global/Dim/.....
   varstr = ""

   ' special case
   If Left$(UCase$(varDeclare), 5) = "REDIM" And UCase$(w(b)) = "PRESERVE" Then
      varstr = w(b) & " "
      Incr b
   End If

   varstr &= w(b) ' add it to variable string
#If 0
   str1 = Right$(varstr, 1) ' check for old style typing
   oldstyle = InStr("%!@#&$", str1) ' 02/14/2012 fix -- add $
   If %DmpVar = 1 Then
      Print #fc.fhout, ">"; varstr; "< oldstyle ="; Str$(oldstyle)
   End If
#EndIf

   ' check to see if array (..)
   Do
      ' 02/14/2012 move oldstyle chk here
      str1 = Right$(varstr, 1) ' check for old style typing
      oldstyle = InStr("%!@#&$", str1) ' 02/14/2012 fix -- add $
      If %DmpVar = 1 Then
         Print #fc.fhout, ">"; varstr; "< oldstyle ="; Str$(oldstyle)
      End If

      Incr b
      If w(b) = "(" Then ' process info within parens
         inParens = 0
         Do
            If w(b) = "(" Then Incr inParens
            If w(b) = ")" Then Decr inParens

            If w(b) = Chr$(254) Then ' 3 exceptions need spaces around them
               varstr &= ", "
            ElseIf w(b) = Chr$(253) Then
               varstr &= ": "
            ElseIf w(b) = ")" And inParens = 1 Then ' 02/14/2012
               varstr = RTrim$(varstr)
               varstr &= w(b)
            'ELSEIF UCASE$(w(b)) = "TO" THEN
            ElseIf w(b) <> "(" Then ' 01/06/2012
               varstr &= w(b) & " "
            Else
               varstr = RTrim$(varstr)
               varstr &= w(b)
            End If
            Incr b
         Loop Until inParens = 1 And w(b) = ")" ' 02/14/2012
         varstr = RTrim$(varstr)
         varstr &= w(b)
         Incr b
      End If

      If b = ixAS Then ' we are at AS table entry
         If w(ixEndAS) = ""  Then rtc = 1 ' stop
         If w(ixEndAS) = "," Then rtc = 2 ' loop again
         If w(ixEndAS) = ":" Then rtc = 3 ' full loop
      ElseIf w(b) = "," Then ' more variables
         Incr b
      ElseIf w(b) = "" Then ' end of line
         rtc = 1
      ElseIf w(b) = ":" Then ' more something to follow?
         ixEndAs = b
         rtc = 3 ' colon
      ElseIf ixEndAs > WordCount Then ' end of line
         rtc = 1 ' stop
      End If
      If oldstyle > 0 Then ' old style typing
         holdAS = strAS
         strAS = ""
      End If
      If Len(varstr) <= maxfixsize Then ' it fits within declare and AS
         LSet varfixsize = varstr
         str1 = Space$(fc.indent) & varDeclare & varfixsize & strAS
         'PRINT #fc.fhout, str1;
      Else ' it doesn't fit so add the parts
         str1 = Space$(fc.indent) & varDeclare & varstr & strAS
         'PRINT #fc.fhout, str1;
      End If
      If oldstyle > 0 Then ' 12/21/2011 hold it for a moment
         strAS = holdAS
         holdAS = ""
         oldstyle = 0
      End If
      If Len(comment) = 0 Then ' no comment
         Print #fc.fhout, RTrim$(str1) ' 01/06/2012  in case of no AS
      Else
         a = Len(str1)
         If a < fo.remcol Then ' there is room before the REM column
            Print #fc.fhout, str1; Space$(fo.remcol - a - 1); comment ' 01/11/2012 fix
         Else ' it goes past REM column so just add a space then the comment
            Print #fc.fhout, str1; " "; comment ' 01/11/2012 fix
         End If
         comment = ""
      End If
      varstr = w(b) ' start building the next variable string
   Loop Until rtc > 0 ' until we've reached , or : or end of line

   If rtc = 2 Then ixBase = ixEndAS: GoTo agn2 ' reached ,
   If rtc = 3 Then ixBase = ixEndAS + 1: GoTo agn ' reached :
   rtc = 1

DunSplit:
   Function = rtc

End Function


Function FindFinalRem(txtIn As String) As Long

    Local x    As Long
    Local y    As Long
    Local txt2 As String

    txt2 = UCase$(txtIn)

    ' 10/23/2011
    If Left$(txt2, 4) = "REM " Then
       x = 1
       GoTo dun
    End If
    Replace ":REM " With "'" In txt2
    Replace ": REM " With "'" In txt2
    Replace ":  REM " With "'" In txt2
    Replace ":   REM " With "'" In txt2

    x = InStr(txt2, $Sq)
    If x < 1 Then GoTo dun
again:
    y = Tally(Left$(txt2, x - 1), $Dq)
    If y = 0 Then GoTo dun
    If y Mod 2 = 0 Then GoTo dun ' x is final rem
    y = InStr(x + 1,txt2, $Dq)
    If y = 0 Then ' no final quote
       x = 0
       GoTo dun
    End If
    x = InStr(y + 1, txt2, $Sq)
    If x > 0 Then
      GoTo again
    End If

dun:
   Function = x
End Function

' go from currentline + 1 until END but do NOT process it -- allow to run thru normally
'
Sub AlignTypeUnion
   Local varBgn As Long
   Local varEnd As Long
   Local lenName As Long
   Local lenAs As Long
   Local now As Long
   Local x As Long
   Local z As Long
   Local comment As String
   Local wrk As String
   Local strVar As String
   Local strAS As String

   Local Wordcount          As Long                    '# tokens in source line
   Local ztext              As AsciiZ * %MAX_LINELEN   'source code line
   Dim   w(100)             As Local String            'words/tokens in line
   Local build              As String                  'rebuilt source line

   varBgn = fc.currentline + 1
   now = varBgn
   ' get var & AS len  and find END
   Do
      ztext = strTbl(now)
      WordCount = Line2Words(ztext, w())
      If UCase$(w(1)) = "END" Then
         Exit Loop
      End If
      If Left$(w(1), 1) = "#" Or Left$(w(1), 1) = "$" Then ' probably #IF or #ELSE or #ENDIF or synonym
         Incr now
         Iterate Loop
      End If
      If Left$(w(1), 1) = "'" Then
         Incr now
         Iterate Loop
      End If
      If Left$(w(WordCount), 1) = "'" Then
         ' comment = w(WordCount) not in first pass
         w(WordCount) = ""
         Decr WordCount
      End If
      If WordCount < 2 Then ' odd entry -- ignore
         Incr now
         Iterate Loop
      End If
      build = w(1)
      x = 2
      While x <= WordCount
         If UCase$(w(x)) = "AS" Then
            Exit Loop
         End If
         If w(x) = "," Then
            build &= " , "
         ElseIf w(x) = ":" Then
            build &= " : "
         ElseIf UCase$(w(x)) = "TO" Then
            build &= " " & w(x) & " "
         Else
            build &= w(x)
         End If
         Incr x
      Wend
      If Len(build) > lenName Then lenName = Len(build)
      If w(x) = "" Then
         Incr now
         Iterate Loop
      End If
      build = w(x)
      Incr x
      While x <= WordCount
         build &= " " & w(x)
         Incr x
      Wend
      If Len(build) > lenAS Then lenAS = Len(build)
      Incr now
   Loop
   varEnd = now - 1

   For z = varBgn To varEnd
      ztext = strTbl(z)
      WordCount = Line2Words(ztext, w())

      If fo.keywordCase <> 1 Then
         CheckPBKeywordCase 2, WordCount, w()
      End If

      If Left$(w(1), 1) = "#" Or Left$(w(1), 1) = "$" Then ' probably #IF or #ELSE or #ENDIF or synonym
         Print #fc.fhout, wrk
         Iterate For
      End If
      If Left$(w(1), 1) = "'" Then
         Print #fc.fhout, Space$(fc.indent); ztext
         Iterate For
      End If
      If Left$(w(WordCount), 1) = "'" Then
         comment = w(WordCount)
         w(WordCount) = ""
         Decr WordCount
      End If

      If WordCount < 2 Then ' odd entry -- ignore
         Print #fc.fhout, Space$(fc.indent);
         If Len(comment) > 0 Then
            Print #fc.fhout, ztext; Space$(fo.tabsize); comment
            comment = ""
         Else
            Print #fc.fhout, RTrim$(ztext)
         End If
         Iterate For
      End If

      build = w(1)
      x = 2
      While x <= WordCount ' gather all things until AS -- most likely () array info
         If UCase$(w(x)) = "AS" Then
            Exit Loop
         End If
         If w(x) = "," Then
            build &= " , "
         ElseIf w(x) = ":" Then
            build &= " : "
         ElseIf UCase$(w(x)) = "TO" Then
            build &= " " & w(x) & " "
         Else
            build &= w(x)
         End If
         Incr x
      Wend

      strVar = build
      strAS = ""

      If w(x) <> "" Then
         strAS = w(x)
         Incr x
         While x <= WordCount
            strAS &= " " & w(x)
            Incr x
         Wend
      End If

      wrk = Space$(fc.indent) & LSet$(strVar, lenName + fo.tabsize) & LSet$(strAS, lenAS)
      If Len(comment) > 0 Then
         wrk &= Space$(fo.tabsize) & comment
         comment = ""
      Else
         wrk = RTrim$(wrk)
      End If
      Print #fc.fhout, wrk
   Next
   fc.currentline = varEnd

End Sub


' go from currentline + 1 until END but do NOT process it -- allow to run thru normally
'
Sub IndentEnum
   Local varBgn As Long
   Local varEnd As Long
   Local lenName As Long
   Local lenEQ As Long
   Local now As Long
   Local x As Long
   Local y As Long
   Local comment As String
   Local wrk As String
   Local uwrk As String
   Local strVar As String
   Local strEQ As String

   varBgn = fc.currentline + 1
   now = varBgn
   Do
      wrk = strTbl(now)
      wrk = Trim$(UCase$(wrk))
      If Left$(wrk, 4) = "END " Then
         Exit Loop
      End If
      If Left$(wrk, 1) = "#" Or Left$(wrk, 1) = "$" Then ' probably #IF or #ELSE or #ENDIF or synonym
         Incr now
         Iterate Loop
      End If
      x = FindFinalRem(wrk)
      If x = 1 Then
         Incr now
         Iterate Loop
      End If
      If x > 1 Then
         ' comment = mid$(wrk, x) not in first pass
         wrk = RTrim$(Left$(wrk, x - 1))
      End If

      x = InStr(wrk, "=")
      If x = 0 Then ' another oddity -- ignore
         If Len(wrk) > lenName Then lenName = Len(wrk)
         Incr now
         Iterate Loop
      End If
      uwrk = Left$(wrk, x - 1)
      uwrk = RTrim$(uwrk)
      If Len(uwrk) > lenName Then
         lenName = Len(uwrk)
      End If
      uwrk = Mid$(wrk, x)
      x = Len(uwrk)
      If Mid$(uwrk, 2, 1) <> " " Then Incr x
      If x > lenEQ Then lenEQ = x
      Incr now
   Loop
   varEnd = now - 1

   For y = varBgn To varEnd
      wrk = Trim$(strTbl(y))
      If Left$(wrk, 1) = "#" Or Left$(wrk, 1) = "$" Then ' probably #IF or #ELSE or #ENDIF or synonym
         Print #fc.fhout, wrk
         Iterate For
      End If
      x = FindFinalRem(wrk)
      If x = 1 Then
         Print #fc.fhout, Space$(fc.indent); wrk
         Iterate For
      End If
      If x > 1 Then
         comment = Mid$(wrk, x)
         wrk = RTrim$(Left$(wrk, x - 1))
      End If

      x = InStr(wrk, "=")
      If x = 0 Then ' another oddity -- ignore
         Print #fc.fhout, Space$(fc.indent);
         If Len(comment) > 0 Then
            Print #fc.fhout, wrk; Space$(fo.tabsize); comment
            comment = ""
         Else
            Print #fc.fhout, RTrim$(wrk)
         End If
         Iterate For
      End If
      strVar = Left$(wrk, x - 1)
      strEQ = Mid$(wrk, x)
      If Mid$(strEQ, 2, 1) <> " " Then
         strEQ = "= " & Mid$(strEQ, 2)
      End If
      wrk = Space$(fc.indent) & LSet$(strVar, lenName + fo.tabsize) & LSet$(strEQ, lenEQ)
      If Len(comment) > 0 Then
         wrk &= Space$(fo.tabsize) & comment
         comment = ""
      Else
         wrk = RTrim$(wrk)
      End If
      Print #fc.fhout, wrk
   Next
   fc.currentline = varEnd
End Sub

Sub CheckPBKeywordCase(ByVal bgn As Long, ByVal WordCount As Long, ByRef w() As String)
   Local x As Long
   Local y As Long
   Local z1 As Long
   Local z2 As Long
   Local skip As Long
   Local wrk As String

   For x = bgn To WordCount
      If skip > 0 Then
         Decr skip
         Iterate For
      End If
      If Len(w(x)) > 1 Then
         wrk = w(x)

         ' combine if . follows
         If w(x + 1) = "." Then
            skip = 2
            wrk &= w(x + 1) & w(x + 2)
         End If
         If w(x + 3) = "." Then
            skip = 4
            wrk &= w(x + 3) & w(x + 4)
         End If

         Array Scan PBKeywords(), Collate UCase, = UCase$(wrk), To y
         If y > 0 Then ' found a match
            If fo.keywordCase = 2 Then ' mixed
               If skip = 0 Then
                  w(x) = PBKeywords(y)
               Else ' multi part
                  z1 = InStr(wrk, ".")
                  w(x) = Left$(PBKeywords(y), z1 - 1)
                  If skip = 2 Then ' only 2 parts
                     w(x + 2) = Mid$(PBKeywords(y), z1 + 1)
                  Else             ' 3 parts
                     z2 = InStr(z1 + 1, wrk, ".")
                     w(x + 2) = Mid$(PBKeywords(y), z1 + 1, z2 - z1 - 1)
                     w(x + 4) = Mid$(PBKeywords(y), z2 + 1)
                  End If
               End If
            ElseIf fo.keywordCase = 3 Then ' upper
               w(x) = UCase$(w(x))
               If skip > 0 Then ' multi part 1st part already done
                  w(x + 2) = UCase$(w(x + 2))
               End If
               If skip > 2 Then
                  w(x + 4) = UCase$(w(x + 4))
               End If
            Else ' lower
               w(x) = LCase$(w(x))
               If skip > 0 Then ' multi part 1st part already done
                  w(x + 2) = LCase$(w(x + 2))
               End If
               If skip > 2 Then
                  w(x + 4) = LCase$(w(x + 4))
               End If
            End If
         End If
      End If
   Next
End Sub

' go from currentline until something other than REM or blank or % =
'
Sub MultEquateLine
   Local skip As Long
   Local varBgn As Long
   Local varEnd As Long
   Local xit As Long
   Local now As Long
   Local x As Long
   Local y As Long
   Local z As Long
   Local z1 As Long
   Local comment As String
   Local wrk As String
   Local uwrk As String
   Local strVar As String
   Local strEQ As String
   Local lenName As Long
   Local lenEQ As Long
   Dim   w(100) As String
   Local zwrk As AsciiZ * %MAX_LINELEN

   varBgn = fc.currentline
   now = varBgn
   Do
      If now > fc.totallines Then
         Exit Loop
      End If
      wrk = strTbl(now)
      wrk = Trim$(UCase$(wrk))
      If wrk = "" Or Left$(wrk, 1) = "'" Or Left$(wrk, 3) = "REM" Then
         Incr now
         Iterate Loop
      End If
      x = FindFinalRem(wrk)
      If x = 1 Then
         Incr now
         Iterate Loop
      End If

      If Left$(wrk, 1) = "%" Or Left$(wrk, 1) = "$" Then
         y = InStr(wrk, "=")
         If y > 1 Then
            uwrk = Left$(wrk, y - 1)
            uwrk = RTrim$(uwrk)
            Array Scan PBKeywords(), Collate UCase, = uwrk, To y
            If y > 0 Then ' starts with PB Keyword
               Exit Loop
            End If
         End If
         ' continue
      Else
         Exit Loop
      End If

      If x > 1 Then
         ' comment = mid$(wrk, x) not in first pass
         wrk = RTrim$(Left$(wrk, x - 1))
      End If

      Do
         x = InStr(wrk, "=")
         If x = 0 Then ' another oddity -- ignore
            If Len(wrk) > lenName Then lenName = Len(wrk)
            Exit Loop
         End If
         uwrk = Left$(wrk, x - 1)
         uwrk = RTrim$(uwrk)
         If Len(uwrk) > lenName Then
            lenName = Len(uwrk)
         End If
         wrk = Mid$(wrk, x + 1)
         x = InStr(wrk, ":")
         If x > 1 Then
            uwrk = Left$(wrk, x - 1)
            wrk = Mid$(wrk, x + 1)
            wrk = Trim$(wrk)
         Else
            uwrk = wrk
            wrk = ""
         End If
         zwrk = Trim$(uwrk)
         x = Line2Words(zwrk, w())
         uwrk = ""
         For z = 1 To x
            If z > 1 Then
               uwrk &= " "
            End If
            uwrk &= w(z)
         Next
         ' break apart & rebuild
         x = Len(uwrk)
         If x > lenEQ Then lenEQ = x
      Loop Until wrk = ""
      Incr now
   Loop
   varEnd = now - 1

   For y = varBgn To varEnd
      wrk = Trim$(strTbl(y))
      x = FindFinalRem(wrk)
      If x = 1 Or wrk = "" Then
         Print #fc.fhout, Space$(fc.indent); wrk
         Iterate For
      End If
      If x > 1 Then
         comment = Mid$(wrk, x)
         wrk = RTrim$(Left$(wrk, x - 1))
      End If

      uwrk = Space$(fc.indent)

      Do
         x = InStr(wrk, "=")
         If x = 0 Then ' another oddity -- ignore
            uwrk &= wrk
            Exit Loop
         End If
         strVar = Left$(wrk, x - 1)
         If fo.capequates Then
            strVar = UCase$(strVar)
         End If
         wrk = Mid$(wrk, x + 1)
         x = InStr(wrk, ":")
         If x > 1 Then
            strEQ = Left$(wrk, x - 1)
            wrk = Mid$(wrk, x + 1)
            wrk = Trim$(wrk)
         Else
            strEQ = wrk
            wrk = ""
         End If
         zwrk = Trim$(strEQ)
         z1 = Line2Words(zwrk, w())
         strEQ = ""
         For z = 1 To z1
            If z > 1 Then
               strEQ &= " "
            End If
            If fo.capequates Then
               If Left$(w(z), 1) = "%" Or Left$(w(z), 1) = "$" Then
                  w(z) = UCase$(w(z))
               End If
            End If
            strEQ &= w(z)
         Next

         uwrk &= LSet$(strVar, lenName + fo.tabsize) & "= " & LSet$(strEQ, lenEQ)
         If x > 1 Then
            uwrk &= " : "
         End If
      Loop Until wrk = ""

      If Len(comment) > 0 Then
         uwrk &= Space$(fo.tabsize) & comment
         comment = ""
      Else
         uwrk &= RTrim$(wrk)
      End If
      Print #fc.fhout, uwrk
   Next
   fc.currentline = varEnd

End Sub


Function LdWN10keys Common As Long
   Local cnt As Long
   Local x As Long

   cnt = DataCount
   ReDim PBKeyWords(1 To cnt) As Global String
   For x = 1 To cnt
      PBKeyWords(x) = Read$(x)
   Next
   Function = cnt
   Exit Function

#Include "WN10KEYS.inc"
End Function

Function LdCC06keys Common As Long
   Local cnt As Long
   Local x As Long

   cnt = DataCount
   ReDim PBKeyWords(1 To cnt) As Global String
   For x = 1 To cnt
      PBKeyWords(x) = Read$(x)
   Next
   Function = cnt
   Exit Function

#Include "CC06KEYS.inc"
End Function
